<?php
App::uses('EvSlideShowAppModel', 'EvSlideShow.Model');

/**
 * SlideshowSlide Model
 *
 */
class Slide extends EvSlideShowAppModel {

	public $imageSlots = array(
		'main' => array(
			'slots' => 1,
			'fields' => false
		)
	);

/**
 * Validation rules
 *
 * @var array
 */
	public $validate = array(
		'name' => array(
			'required' => array(
				'rule' => 'notEmpty',
				'message' => 'Required'
			),
		),
	);


/**
 * Get active slides.
 * 
 * @param array $params (optional) find parameters
 * @return array
 */
	public function getSlides($params = array()) {

		$defaultParams = array(
			'order' => array('orderno' => 'ASC'),
			'contain' => array(
				'Image'
			),
			'conditions' => array(
				$this->escapeField('is_active') => true
			)
		);

		$params = array_merge_recursive($defaultParams, $params);

		$data = $this->find('all', $params);

		return $data;

	}


	public function beforeSave($options = array()) {
	
		$extra = array();
		$extra_found = false;

		foreach ($this->data[$this->alias] as $field => $value) {

			if (substr($field, 0, 6) == 'extra_') {

				$extra_found = true;
				$extra[substr($field, 6)] = $value;
				unset($this->data[$this->alias][$field]);
			
			}

		}

		if ($extra_found) {
			$this->data[$this->alias]['extra'] = serialize($extra);
		}

		return true;

	}


	public function afterFind($results, $primary = false) {

		foreach ($results as $k => $slide) {

			if (isset($slide[$this->alias]['extra'])) {

				$extra = unserialize($slide[$this->alias]['extra']);

				if (is_array($extra)) {

					foreach ($extra as $key => $value) {

						$results[$k][$this->alias]['extra_' . $key] = $value;
					}
				}
				unset($results[$k][$this->alias]['extra']);

			}

		}

		return $results;
	}

}
